--Options for the Buff Monitoring function

function ShowMonitorOption(self)

	--Update the bufflist[PlayerClass] with effects currently on the player.

	local n=effects:GetCount()

		for j=1,n do
			local thiseffect=effects:Get(j)
			CollectBuff(thiseffect)
		end
	table.sort(bufflist[PlayerClass])
	for j in pairs(bufflist[PlayerClass]) do
		table.sort(bufflist[PlayerClass][j])
	end

	MonitorOption={}
	
	if self.Data.monitor==nil then self.Data.monitor={} end

	--Make the window	
	MonitorOption.Window = Turbine.UI.Lotro.Window()
	MonitorOption.Window:SetPosition( 100,100 )
	MonitorOption.Window:SetSize(400,400)

	MonitorOption.Window:SetText( self.Data.name.." Monitor for Buff;")
	MonitorOption.Window:SetVisible( true )
	MonitorOption.Window:SetZOrder(1000)

	MonitorOption.ScrollBar=Turbine.UI.Lotro.ScrollBar()
	MonitorOption.ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )

	MonitorOption.ListBox = Turbine.UI.ListBox()
	MonitorOption.ListBox:SetParent( MonitorOption.Window )
	MonitorOption.ListBox:SetPosition( 30, 40 )
	MonitorOption.ListBox:SetSize( 350, 300)
	--MonitorOption.ListBox:SetMaxItemsPerLine(1)
	MonitorOption.ListBox:SetMaxColumns(1)
	MonitorOption.ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
	MonitorOption.ListBox:SetVerticalScrollBar( MonitorOption.ScrollBar )
	MonitorOption.ScrollBar:SetParent(MonitorOption.Window)
	MonitorOption.ScrollBar:SetPosition(20,40)
	MonitorOption.ScrollBar:SetHeight(300)
	MonitorOption.ScrollBar:SetWidth(10)

	--The main list options.
	
	MonitorOption.frame={}
	MonitorOption.Option={}
	MonitorOption.Button={}
	local function Option(i,txt)
		--Frame to hold the textbox and control
		MonitorOption.frame[i]=Turbine.UI.Control()
		MonitorOption.frame[i]:SetSize(350,24)
		
		MonitorOption.Button[i]=Turbine.UI.Button()
		MonitorOption.Button[i]:SetPosition(2,2)
		MonitorOption.Button[i]:SetSize(16,16)
		MonitorOption.Button[i]:SetBackground(0x41007e27)
		MonitorOption.Button[i]:SetParent(MonitorOption.frame[i])
		
		MonitorOption.Button[i].MouseClick=function()
			--Now for a nice little menu with submenus!
			local contextMenu = Turbine.UI.ContextMenu()
			contextMenu.items = contextMenu:GetItems()
			
				local suboption={}
				for j in pairs(bufflist[PlayerClass]) do
					suboption[j] = Turbine.UI.MenuItem(Debufftext[j])
					contextMenu.SubSubMenuItems=suboption[j]:GetItems()
					
					--#bufflist[PlayerClass][j]
					--suboption[j].Click= function () MonitorOption.Option[i]:SetText(bufflist[PlayerClass][j][k]) end
					for k=1,26 do
							suboption[j][k] = Turbine.UI.MenuItem(string.char(64+k))
							contextMenu.SubSubSubMenuItems=suboption[j][k]:GetItems()
							local item=false
							for l=1,#bufflist[PlayerClass][j] do
									if string.byte(bufflist[PlayerClass][j][l])==(64+k) then
										item=true
										suboption[j][k][l] = Turbine.UI.MenuItem(bufflist[PlayerClass][j][l])
										suboption[j][k][l].Click= function () MonitorOption.Option[i]:SetText(bufflist[PlayerClass][j][l]) end
										contextMenu.SubSubSubMenuItems:Add(suboption[j][k][l])
									end
							end
							if item then contextMenu.SubSubMenuItems:Add(suboption[j][k]) end
					end
					contextMenu.items:Add(suboption[j])
				end
			contextMenu:ShowMenu()
			end
		
		MonitorOption.Option[i]=Turbine.UI.TextBox()
		MonitorOption.Option[i]:SetSize(326,20)
		MonitorOption.Option[i]:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
		MonitorOption.Option[i]:SetText(txt)
		MonitorOption.Option[i]:SetParent(MonitorOption.frame[i])
		MonitorOption.Option[i]:SetPosition(24,2)
		MonitorOption.Option[i]:SetBackColor(Turbine.UI.Color(1,0.2,0.2,0.2))
		MonitorOption.ListBox:AddItem(MonitorOption.frame[i])
	end
	
--Current List
	for i=1,#self.Data.monitor do
		Option(i,self.Data.monitor[i])
	end
--One blank one, if none there.	
	if #self.Data.monitor==0 then
		i=1
		Option(i,self.Data.monitor[i])
	end
	
	MonitorOption.Add = Turbine.UI.Lotro.Button()
	MonitorOption.Add:SetSize(90,30)
	MonitorOption.Add:SetText("Add new")
	MonitorOption.Add:SetParent(MonitorOption.Window)
	MonitorOption.Add:SetPosition(110,360)
	MonitorOption.Add.Click= function (sender, args)
		i=#MonitorOption.Option+1
		Option(i,self.Data.monitor[i])
	end

	MonitorOption.ClearAll = Turbine.UI.Lotro.Button()
		MonitorOption.ClearAll:SetSize(90,30)
		MonitorOption.ClearAll:SetText("Clear All")
		MonitorOption.ClearAll:SetParent(MonitorOption.Window)
		MonitorOption.ClearAll:SetPosition(30,360)
		MonitorOption.ClearAll.Click= function (sender, args)
			MonitorOption.Window:Close()
			self.Data.monitor=nil
			self.Data.monitorNOT=nil
		end
	
	MonitorOption.NOT=Turbine.UI.Lotro.CheckBox()
		MonitorOption.NOT:SetChecked(self.Data.monitorNOT)
		MonitorOption.NOT:SetText("NOT got buff(s)")
		MonitorOption.NOT:SetFont(Turbine.UI.Lotro.Font.Verdana10)
		MonitorOption.NOT:SetSize(360,40)
		MonitorOption.NOT:SetParent(MonitorOption.Window)
		MonitorOption.NOT:SetPosition(200,360)
		
	MonitorOption.Window.Closed=function(sender,args)
		local count=0
		for i=1,#MonitorOption.Option do
			local txt=MonitorOption.Option[i]:GetText()
			if txt~="" then
				count=count+1
				self.Data.monitor[count]=txt
			end
		end
		self.Data.monitorNOT=MonitorOption.NOT:IsChecked()
		
		if count==0 then
			self.Data.monitor=nil
			self.Data.monitorNOT=nil
		end
				
		ModulesShowHide()
		
		MonitorOption=nil
	end

end
	