--New Options box
--***************

--[[
Opt,Opt.Module,Opt.source,Opt.bool,Opt.table are defined in Main.Lua.
]]

--In modules functions can be added to Opt.Module and these will be run in Opt.Create.
--By adding statments to Opt.source,bool and table you can define what happens when Opt.Update is run.
--By adding functions to Opt.Updaters other controls, rather than just flags/numerical, can be updated to the contents. - as well as using Opt.Check to update the shading.

--Create the frame.
function Opt.Create()
--Create Window
	Opt.Window=Turbine.UI.Lotro.Window()
		Opt.Window:SetText( "Bevy Options")
		Opt.Window:SetVisible( false )

--Resizer
	Opt.Resize=Turbine.UI.Control()
		Opt.Resize:SetParent(Opt.Window)
		Opt.Resize:SetZOrder(99)
		Opt.Resize:SetSize(10,10)
		
		Opt.ResizeBack=Turbine.UI.Control()
		Opt.ResizeBack:SetParent(Opt.Resize)
		Opt.ResizeBack:SetSize(10,10)
		Opt.ResizeBack:SetBackColor(Turbine.UI.Color(1,1,1,1))
		Opt.ResizeBack:SetVisible(false)
		Opt.ResizeBack:SetMouseVisible(false)

		Opt.Resize.MouseEnter=function() Opt.ResizeBack:SetVisible(true) end
		Opt.Resize.MouseLeave=function() Opt.ResizeBack:SetVisible(false)  end

		Opt.Resize.MouseDown=function ()
			Opt.dragging=true
		end
		Opt.Resize.MouseUp=function ()
			Opt.dragging=false
		end
		Opt.Resize.MouseMove=function()
			if Opt.dragging then
				local width,height=Opt.Window:GetMousePosition()
				if width<250 then width=250 end
				Opt.Window:SetSize(width,height)
			end
		end

--Main Listbox - holds all other controls
	Opt.ListBox=Turbine.UI.ListBox()
		Opt.ListBox:SetParent(Opt.Window)
		Opt.ListBox:SetPosition(10,30)
		Opt.ListBox:ClearItems()

		Opt.ListBox.ScrollBar = Turbine.UI.Lotro.ScrollBar()
			Opt.ListBox.ScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
			Opt.ListBox.ScrollBar:SetParent( Opt.Window )
			Opt.ListBox.ScrollBar:SetPosition( 5, 20 )
		
		Opt.ListBox:SetVerticalScrollBar( Opt.ListBox.ScrollBar )
		
	Opt.Window.SizeChanged=function()
		local w=Opt.Window:GetWidth()
		local h=Opt.Window:GetHeight()
		Opt.ListBox:SetSize(w-20,h-40)
		Opt.ListBox.ScrollBar:SetSize(5,h-40)
		for i=1,Opt.ListBox:GetItemCount() do
			Opt.ListBox:GetItem(i):SetWidth(w-20)
		end
		Opt.Resize:SetPosition(w-10,h-10)
		Opt.Width=w
		Opt.Height=h
	end

--1: Label: Number of bars selected. If 1 then just its name. Bar calling shoule be selected automatically.
	Opt.text=Turbine.UI.Label()
		Opt.text:SetParent(self)
			Opt.text:SetSize( 500, 18 )
		Opt.ListBox:AddItem(Opt.text)
		
		Opt.NameBox=Turbine.UI.Control()
			Opt.NameBox:SetSize(500,20)
			Opt.NameLabel=optionlabel(50,"Name:")
			Opt.Name=optiontextbox(300,20)
			Opt.NameLabel:SetParent(Opt.NameBox)
			Opt.Name:SetParent(Opt.NameBox)
			Opt.Name:SetLeft(50)
			
			Opt.NameBox.SizeChanged=function()
				local w=Opt.NameBox:GetWidth()
				Opt.Name:SetSize(w-50,20)
			end
			
		Opt.ListBox:AddItem(Opt.NameBox)
		
		Opt.SelectAll=Turbine.UI.Lotro.Button()
		Opt.SelectAll:SetText("Select All")
		Opt.SelectAll.MouseDown=function() for i=1,#Bar do	if Bar[i].delete==false then Bar[i].Checked=true end end Opt.Update() end
		
		Opt.SelectNone=Turbine.UI.Lotro.Button()
		Opt.SelectNone:SetText("Select None")
		Opt.SelectNone.MouseDown=function() for i=1,#Bar do	if Bar[i].delete==false then Bar[i].Checked=false end end Opt.Update() end
		
		Opt.AddBar=Turbine.UI.Lotro.Button()
		Opt.AddBar:SetText("Add Bar")
		Opt.AddBar.MouseDown=function() 
			i=#Bar+1
			Bar[i]=NewBar()
			Bar[i]:SetSize(3,3)
			Bar[i]:SetPosition(0,20)
			Bar[i]:SetColor({1,0,0,0})
			Bar[i]:ShowButton(true)
			renamebars()
			--Call the snapper setting
			Bar[i]:Snapper()

			Opt.Update(Bar[i]) 
		end
	
--2: CollapseBox: Giving list of bars - just a table with differing numbers of columns depending on width of Opt?
	Opt.Bars=CollapseBox("Bars Selected","f",4,false)
	Opt.ListBox:AddItem(Opt.Bars)
	
	Opt.Bars.BarItem={}
	
--3: Legacy - nothing to see here...

--4: CollapseBox: Multi Bar section
	--Everything from the current option dialogue
	--sx,sy,gap,pad,colour,position
	Opt.Multi=CollapseBox("Size Options","f",2,true)
	Opt.ListBox:AddItem(Opt.Multi)
	--Bar Size
	Opt.sx=Opt.Slider("sx",1,10,		function(sx,i) 	 	if sx<1 then sx=1 end Bar[i]:SetSize(sx,Bar[i].Data.sy) 	if Modules.skin then Bar[i]:Skin() end end)
	Opt.sy=Opt.Slider("sy",1,10,		function(sy,i) 		if sy<1 then sy=1 end Bar[i]:SetSize(Bar[i].Data.sx,sy) 	if Modules.skin then Bar[i]:Skin() end end)
	
	--Gap, Pad and Icon Size
	--NINDYR Patch
	--Opt.pad=Opt.Slider("Pad",0,36,		function(pad,i) 	Bar[i]:SetSize(nil,nil,pad)				if Modules.skin then Bar[i]:Skin() end end)
	Opt.padl=Opt.Slider("L Pad",0,36,		function(padl,i) 	Bar[i]:SetSize(nil,nil,nil,nil,nil,padl)				if Modules.skin then Bar[i]:Skin() end end)
	Opt.padr=Opt.Slider("R Pad",0,36,		function(padr,i) 	Bar[i]:SetSize(nil,nil,nil,nil,nil,nil,padr)				if Modules.skin then Bar[i]:Skin() end end)
	Opt.padt=Opt.Slider("T Pad",0,36,		function(padt,i) 	Bar[i]:SetSize(nil,nil,nil,nil,nil,nil,nil,padt)				if Modules.skin then Bar[i]:Skin() end end)
	Opt.padb=Opt.Slider("B Pad",0,36,		function(padb,i) 	Bar[i]:SetSize(nil,nil,nil,nil,nil,nil,nil,nil,padb)				if Modules.skin then Bar[i]:Skin() end end)
	Opt.gap=Opt.Slider("Gap",0,36,		function(gap,i)		Bar[i]:SetSize(nil,nil,nil,gap)			if Modules.skin then Bar[i]:Skin() end end)
	Opt.size=Opt.Slider("Size",16,64,	function(size,i)	Bar[i]:SetSize(nil,nil,nil,nil,size)	if Modules.skin then Bar[i]:Skin() end end)
	--End Patch
	
	--Backdrop Opacity
	Opt.opacity=Opt.Slider("Opacity",0,100,	function(c,i)	Bar[i]:SetColor({c/100,Bar[i].Data.color[2],Bar[i].Data.color[3],Bar[i].Data.color[4]}) end)
	
	Opt.Multi.Content:AddItem(Opt.sx)
	Opt.Multi.Content:AddItem(Opt.sy)
	--NINDYR Patch
	--Opt.Multi.Content:AddItem(Opt.pad)
	Opt.Multi.Content:AddItem(Opt.padl)
	Opt.Multi.Content:AddItem(Opt.padr)
	Opt.Multi.Content:AddItem(Opt.padt)
	Opt.Multi.Content:AddItem(Opt.padb)
	--End Patch
	Opt.Multi.Content:AddItem(Opt.gap)
	Opt.Multi.Content:AddItem(Opt.size)
	--Opt.Multi.Content:AddItem(Opt.opacity)
	
	--Position
	Opt.x=Opt.Slider("x",0,Turbine.UI.Display.GetWidth(),	function(x,i) 	Bar[i]:SetPosition(x,Bar[i]:GetTop()) end)
	Opt.y=Opt.Slider("y",0,Turbine.UI.Display.GetHeight(),	function(y,i) 	Bar[i]:SetPosition(Bar[i]:GetLeft(),y) end)
	
	Opt.Multi.Content:AddItem(Opt.x)
	Opt.Multi.Content:AddItem(Opt.y)
	
	--Bar Lock
	Opt.lock=Opt.CheckBox("Locked?",function(k,i) Bar[i].Data.lock=k	if k then Bar[i]:Lock() else Bar[i]:Unlock() end end)

	Opt.Multi.Content:AddItem(Opt.opacity)
	Opt.Multi.Content:AddItem(Opt.lock)
	
--5: CollapseBox - Color Area
	--I want to do something much more clever with this - but what?
	
	Opt.Color=CollapseBox("Colour Options","v",10,true)
	Opt.ListBox:AddItem(Opt.Color)
	
	--I have decided to pop for a color swatch of every type.
	--I hope 4^3 options is good enough for folk!
	Opt.Sample={}
		for r=0,4 do
			Opt.Sample[r]={}
			for g=0,4 do
				Opt.Sample[r][g]={}
				for b=0,4 do
					Opt.Sample[r][g][b]=Turbine.UI.Control()
					Opt.Sample[r][g][b]:SetSize(10,10)
					Opt.Sample[r][g][b]:SetBackColor(Turbine.UI.Color(1,r/4,g/4,b/4))
					Opt.Sample[r][g][b].MouseDown=function() Color (r/4,g/4,b/4) end
					Opt.Color.Content:AddItem(Opt.Sample[r][g][b])
				end
			end
		end
	
	--Control to mark out which box has been selected
	Opt.Selected=Turbine.UI.Control()
		Opt.Selected:SetSize(10,10)
		Opt.Selected:SetBackground("/JackdawPlugins/Bevy2/Select.TGA")
		Opt.Selected:SetMouseVisible(false)
		Opt.Selected:SetOpacity(0.5)
		Opt.Selected.Baby=Turbine.UI.Control()
		Opt.Selected.Baby:SetSize(6,6)
		Opt.Selected.Baby:SetParent(Opt.Selected)
		Opt.Selected.Baby:SetPosition(2,2)
		
--6: Optional Modules
	for i=1,#Opt.Module do
		Opt.Module[i]()
	end

Opt.Window:SetSize(Opt.Width,Opt.Height)

	Opt.Window.Closed=function()
		if Modules.fader then initialisefader() for i=1,#Bar do if Bar[i].delete==false then Bar[i]:fader() end	end end		--Sort out the faders
		if Modules.popups and not(Watcher.flag) then CloseAllPops() end		--Close all the popups, if the option window is closed AND the UI is not unlocked.
	end
end

function Opt.Update(i)
Opt.Window:SetVisible(true)

if i~=nil then i.Checked=true end
if Opt.UpdateFlag then return end
Opt.UpdateFlag=true
--Fill in the details when it is called to be shown
--1: Label
	local c=0
	local s
	local text
	for i=1,#Bar do
		if Bar[i].delete==false then
			if Bar[i].Checked then c=c+1 s=i end
		end 
	end 
	
	Opt.text:SetHeight(18)
	Opt.NameBox:SetHeight(0)
	Opt.Name.TextChanged=nil
	
	Opt.OneBar=false
	
	if c==0 then text="No Bars Selected" end
	if c==1 then 
		--Only one bar selected, show the Name Box
		Opt.text:SetHeight( 0 )
		Opt.NameBox:SetSize(Opt.ListBox:GetWidth(),20)
		Opt.Name:SetSize(Opt.ListBox:GetWidth()-50,20)
		Opt.Name:SetText(Bar[s].Data.name)
		Opt.Name.TextChanged=function()
			local name=Opt.Name:GetText()
			local name=string.gsub(name,"[%c]","")
			Bar[s]:SetName(name)
			Opt.Bars.BarItem[s]:SetText(name)
		end
		Opt.OneBar=true
		Opt.OneBarid=s
	end
	if c>1 then text=c.." Bars Selected" end
	
	Opt.text:SetText(text)
--2: Bar list
	Opt.Bars.Content:ClearItems()
	for i=1,#Bar do
		if Bar[i].delete==false then
			if Opt.Bars.BarItem[i]==nil then
				Opt.Bars.BarItem[i]=Turbine.UI.Lotro.CheckBox()
				Opt.Bars.BarItem[i]:SetHeight(20)
				Opt.Bars.BarItem[i]:SetMultiline(false)
				Opt.Bars.BarItem[i]:SetText(Bar[i].Data.name)
				
				Opt.Bars.BarItem[i].CheckedChanged=function()
					Bar[i].Checked=Opt.Bars.BarItem[i]:IsChecked()
					Opt.Update()
				end	
			end
			Opt.Bars.BarItem[i]:SetChecked(Bar[i].Checked)
			Opt.Bars.Content:AddItem(Opt.Bars.BarItem[i])
		end
	end
	
	--Pop out any selected pop-up bars
	if Modules.popups then
		for i=1,#Bar do
			if Bar[i].delete==false then
				if Bar[i].Checked then
					if Bar[i].Data.Pop~=nil then if Bar[i].Popped==false then Bar[i]:PopOpen() end end
				end
			end
		end
	end
	
	Opt.Bars.Content:Sort(
	function (a,b)	
			 return (a:GetText())< (b:GetText()) end

			)
			
	Opt.Bars.Content:AddItem(Opt.SelectAll)
	Opt.Bars.Content:AddItem(Opt.SelectNone)
	Opt.Bars.Content:AddItem(Opt.AddBar)
	
	Opt.Bars.SizeChanged()
	
--4: Multi-bar content
	--First we collect the maximum data in every major class
	--Also, we check to see if all the data is the same.
	
	Opt.Check={}
	Opt.val={}
	Opt.tab={}
	
	for dummy,i in pairs(Opt.source) do
		Opt.Check[i]=false
		Opt.val[i]=0
		if Opt.bool[i] then Opt.val[i]=false end
		if Opt.table[i] then 
			Opt.val[i]=false Opt.tab[i]={} end
	end
	
	--First pass- Biggest piece of data
	for i=1,#Bar do
		if Bar[i].delete==false then
			if Bar[i].Checked then
				--Needs an edit here for the different data types
				for dummy,k in pairs(Opt.source) do
					local t=Bar[i].Data[k]
					if k=="opacity" then
						if math.floor(Bar[i].Data.color[1]*100)>Opt.val[k] then Opt.val[k]=math.floor(Bar[i].Data.color[1]*100) end
					elseif type(t)=="number" then
						if t>Opt.val[k] then Opt.val[k]=t end
					elseif type(t)=="boolean" then
						if t then Opt.val[k]=true end
						if t==false then Opt.val[k]=false end
					elseif type(t)=="table" then
						Opt.val[k]=true
						if Opt.tab[k]==nil then Opt.tab[k]={} end
						for key,value in pairs (t) do
							Opt.tab[k][key]=value
						end
					elseif type(t)=="string" then
						Opt.val[k]=t
					end
				end
			end
		end
	end
	
	--Second pass - Are they all equal?
	for i=1,#Bar do
		if Bar[i].delete==false then
			if Bar[i].Checked then
				for dummy,k in pairs(Opt.source) do
					if k=="opacity" then
						if math.floor(Bar[i].Data.color[1]*100)~=Opt.val[k] then Opt.Check[k]=true end
					elseif Opt.table[k] then
						if (type(Bar[i].Data[k])=="table")~=Opt.val[k] then Opt.Check[k]=true end
					elseif Bar[i].Data[k]~=Opt.val[k] then
						if type(Opt.val[k]=="number") and Bar[i].Data[k]~=Opt.val[k] then
							if Bar[i].Data[k]==nil and Opt.val[k]==0 then
								Opt.Check[k]=false
							else
								Opt.Check[k]=true
							end
						elseif type(Opt.val[k]=="boolean") then
							Opt.Check[k]=true
						end
					end
				end
			end
		end
	end

	--Now, set slider options
	--Whilst some of this HAS to be on a per-bar basis, most is done programmatically.
	
	--NINDYR Patch
	--Opt.sx:SetMax(math.floor((Turbine.UI.Display.GetWidth()-2*Opt.val.pad)/(Opt.val.size+Opt.val.gap))) 	
	--Opt.sy:SetMax(math.floor((Turbine.UI.Display.GetHeight()-2*Opt.val.pad)/(Opt.val.size+Opt.val.gap)))
	Opt.sx:SetMax(math.floor((Turbine.UI.Display.GetWidth()-Opt.val.padl-Opt.val.padr)/(Opt.val.size+Opt.val.gap)))
	Opt.sy:SetMax(math.floor((Turbine.UI.Display.GetHeight()-Opt.val.padt-Opt.val.padb)/(Opt.val.size+Opt.val.gap)))
	
--Highlighting
	
	for k,var in pairs(Opt.source) do
			Opt[var]:SetVal(Opt.val[var])
		--Grey back if not all the same
		if Opt.Check[var] then
			--Not all the Bars have the same value for this slider - set the back to grey
			Opt[var]:SetBackColor(Turbine.UI.Color(1,0.3,0.3,0.3))
		else
			--All the same? Transparent back
			Opt[var]:SetBackColor(nil)
		end
	end	

--Now, do a similar thing for the members of Opt.tab
--But leave other members in place

	for key1,value1 in pairs (Opt.tab) do
		--Detect sub-tables
		if type(Opt.tab[key1])=="table" then
		
			Opt.Check[key1]={}
			
			for key2,value2 in pairs (Opt.tab[key1]) do
				if type(Opt.tab[key1][key2])~="table" then
					for i=1,#Bar do
						if Bar[i].delete==false then
							if Bar[i].Checked then
								if Bar[i].Data[key1]==nil then 
									--defintely not true if it isn't even a table!
									Opt.Check[key1][key2]=true
								elseif Bar[i].Data[key1][key2]~=Opt.tab[key1][key2] then
									Opt.Check[key1][key2]=true
								end
							end
						end
					end
				else
					Opt.Check[key1][key2]={}
						for key3,value3 in pairs (Opt.tab[key1][key2]) do
							for i=1,#Bar do
								if Bar[i].delete==false then
									if Bar[i].Checked then
										if Bar[i].Data[key1]==nil then
											Opt.Check[key1][key2][key3]=true
										elseif Bar[i].Data[key1][key2]==nil then 
											--defintely not true if it isn't even a table!
											Opt.Check[key1][key2][key3]=true
										elseif Bar[i].Data[key1][key2][key3]~=Opt.tab[key1][key2][key3] then
											Opt.Check[key1][key2][key3]=true
										end
									end
								end
							end
						end
				end
			end	
		else
		--Not a table
			for i=1,#Bar do
				if Bar[i].delete==false then
					if Bar[i].Checked then
						if Bar[i].Data[key1]~=Opt.tab[key1] then
							Opt.Check[key2]=true
						end
					end
				end
			end
		end
	end

--4b Code for passing values to sliders, or other inaccesible controls.
	--This is defined on a per-module basis
	--Highlighting for embedded controls has to be done here too
	for i=1,#Opt.Updaters do
		Opt.Updaters[i]()
	end

--5: Color options

	--Not satisfying, but select the last color.
	local r,g,b=0,0,0
	for i=1,#Bar do
		if Bar[i].delete==false then
			if Bar[i].Checked then
				r,g,b=math.floor(Bar[i].Data.color[2]*4),math.floor(Bar[i].Data.color[3]*4),math.floor(Bar[i].Data.color[4]*4)
			end
		end
	end
	Opt.Selected:SetParent(Opt.Sample[r][g][b])
	Opt.Selected.Baby:SetBackColor(Turbine.UI.Color(1,r/4,g/4,b/4))
	
Opt.UpdateFlag=false
end

function Color(r,g,b)
	for i=1,#Bar do
		if Bar[i].delete==false then
			if Bar[i].Checked then
				Bar[i]:SetColor({Bar[i].Data.color[1],r,g,b})
				Opt.Update()
			end
		end
	end
end

--A dummy control
Dummy=class(Turbine.UI.Control)
function Dummy:Constructor()
end
function Dummy:SetVal()
end
function Dummy:SetBackColor()
end

CollapseBox=class(Turbine.UI.Control)
function CollapseBox:Constructor(Name,CT,Width,Rolled)
--Name, Column type ("f" Fixed number, "v" Variable), Number of columns if fixed - Width of columns if variable, Whether to show rolled or unrolled by default.
--[[
	Doesn't need to know it's width - this is set when the window changes size. 
	Doesn't need to know its height - this is set automatically by the contents.
]]
	Turbine.UI.Control.Constructor(self)
	self.CT=CT
	self.C=Width
	self.Rolled=Rolled
	self.Height=100
	
	--Heading
	self.Heading=Turbine.UI.Label()
		self.Heading:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
		self.Heading:SetFontStyle( Turbine.UI.FontStyle.Outline )
		self.Heading:SetParent(self)
		self.Heading:SetBackColor(Turbine.UI.Color(1,0,0,1))
		
		self.Heading.MouseDown=function() 
			self.Rolled=not(self.Rolled) 
			self.SizeChanged() 
		end
	
	--Content
	self.Content=Turbine.UI.ListBox()
		self.Content:SetParent(self)
		self.Content:SetPosition(0,16)
		self.Content:SetOrientation( Turbine.UI.Orientation.Horizontal )
		
	self.Content.ItemAdded=function()
		if self.Rolled then
			self.Height=0
		end
		self:SetHeight(self.Height+18)
	end
		
	--SizeChanged events
	self.SizeChanged=function()
		local w=self:GetWidth()
		local h=self:GetHeight()
		self.Heading:SetSize(w,15)
		self.Content:SetWidth(w)
		self.Height=1
		local c
		if self.CT=="f" then
			--Fixed number of columns
			--self.Content:SetMaxItemsPerLine(self.C)
			self.Content:SetMaxColumns(self.C)
			if self.Content:GetItemCount()>0 then
				for i=1,self.Content:GetItemCount() do
					self.Content:GetItem(i):SetWidth(w/self.C)
				end
			end
			c=self.C
		else
			--Variable number of columns
			c=math.floor(w/self.C)
			--self.Content:SetMaxItemsPerLine(c)
			self.Content:SetMaxColumns(c)
			if c==0 then c=1 end
			for i=1,self.Content:GetItemCount() do
				self.Content:GetItem(i):SetWidth(self.C)
			end
		end
		
		--Scan through each column and add the heights of the maximum item in each row.
		local cm=0
		local mh={}
		local IC=self.Content:GetItemCount()
		for i=1,IC+1 do
			cm=cm+1
			if cm>c or i==IC+1 then 
				cm=1 
				table.sort(mh)
				if mh[#mh]~=nil then
					self.Height=self.Height+mh[#mh]
				end
				mh=nil
				mh={}
			end
			if i<=IC then
				mh[cm]=self.Content:GetItem(i):GetHeight()
			end
		end
				
		self.Content:SetHeight(self.Height)
		
		if self.Rolled then
			self.Heading:SetText("^"..Name)
			self.Height=1
		else
			self.Heading:SetText(">"..Name)
		end
		if h==self.Height+15 then	return end
		
		self:SetHeight(self.Height+15)
	end
end

newoptionslider=class(Turbine.UI.Control)
function newoptionslider:Constructor(label,Min,Max,Val)
	Turbine.UI.Control.Constructor(self)
	
	local labelwidth=50
	local textfield=40

	ScrollBarFudgeFactor=5
	
	self:SetSize(labelwidth+textfield+10,20)

	self.FrameBoxLabel=optionlabel(labelwidth,label)
	
	--Now, to trap negative mins.
	if Min<0 then 
		negval=true
		self.offset=-Min
		Max=Max+self.offset
		Min=0
	else
		self.offset=0
	end

	--NASTY HACK! True length bars screw up as the numbers I am usually using are so small, so here I multiply by ScrollBarFudgeFactor
	self.slider=Turbine.UI.Lotro.ScrollBar()
		self.slider:SetSize(175,10)
		self.slider:SetMinimum( Min*ScrollBarFudgeFactor );
		self.slider:SetMaximum( Max*ScrollBarFudgeFactor );
		self.slider:SetValue( (Val+self.offset)*ScrollBarFudgeFactor );
		self.slider:SetOrientation( Turbine.UI.Orientation.Horizontal );
		self.slider:SetSmallChange(ScrollBarFudgeFactor)
		self.slider:SetLargeChange(2*ScrollBarFudgeFactor)

	--If a return character is sent, or focus is lost, send the value (reformatted as a number) to the slider.
	self.sliderval=optiontextbox(textfield,math.floor(self.slider:GetValue()/ScrollBarFudgeFactor)-self.offset)
		self.sliderval.TextChanged=function()
			local s=self.sliderval:GetText()
			if string.find(s,"\n") then
				s=string.gsub(s, "[^0123456789]","")--strip out all non-numeric characters
				self.slider:SetValue( (tonumber(s)+self.offset)*ScrollBarFudgeFactor)
				self.sliderval:SetText(s)
			end
		end
	self.sliderval.FocusLost=function()
		local s=self.sliderval:GetText()
		s=string.gsub(s, "[^0123456789]","")--strip out all non-numeric characters
		self.slider:SetValue( (tonumber(s)+self.offset)*ScrollBarFudgeFactor)
		self.sliderval:SetText(s)
	end
	
	self.FrameBoxLabel:SetParent(self)
	self.FrameBoxLabel:SetPosition(0,0)
	self.slider:SetParent(self)
	self.slider:SetPosition(textfield,0)
	self.sliderval:SetParent(self)
	self.sliderval:SetPosition(215,0)
	
	self.slider.ValueChanged=function()
		local newval=math.floor(self.slider:GetValue()/ScrollBarFudgeFactor-self.offset)
		self.sliderval:SetText(newval)
		if val~=newval then 
			if SVflag then return end -- Escape if it is just a set value, as opposed to a changed value.
			self.ValueChanged(newval)
			val=newval
			Opt.Update()
		end
	end
	
	self.SizeChanged=function()
		local w=self:GetWidth()
		local bar=w-(labelwidth+textfield)
		
		self.FrameBoxLabel:SetSize(labelwidth,20)
		self.sliderval:SetSize(textfield,20)
		self.slider:SetWidth(bar)
		self.slider:SetLeft(labelwidth)
		self.sliderval:SetLeft(bar+labelwidth)
	end	
	
	self:SetWidth(320)
end

function newoptionslider:SetMax(Max)
	--Set the bars max value.
	self.slider:SetMaximum( Max*ScrollBarFudgeFactor )
end
function newoptionslider:SetVal(Val)
	--Set the slider value WITHOUT changing any bars.
	if Val==nil then Val=0 end
	SVflag=true
	self.slider:SetValue( (Val+self.offset)*ScrollBarFudgeFactor )
	SVflag=false
end

--Function is used to create a stat slider.
	function Opt.Slider(text,minv,maxv,fn)
		local self=newoptionslider(text,minv,maxv,1)
		self.ValueChanged=function(k)
		
			if Opt.UpdateFlag then return end
		
			for i=1,#Bar do
				if Bar[i].delete==false then
					if Bar[i].Checked then
						fn(k,i) 
					end
				end
			end
		end
		return self
	end
	
Opt.CheckBox=class(Turbine.UI.Lotro.CheckBox)
	--Function to create a checkbox style entry
	function Opt.CheckBox:Constructor(text,fn)
		Turbine.UI.Lotro.CheckBox.Constructor(self)
		self:SetSize(50,16)
		self:SetText(text)
		self.CheckedChanged=function()
			if Opt.UpdateFlag then return end
			local k=self:IsChecked()
			
			for i=1,#Bar do
				if Bar[i].delete==false then
					if Bar[i].Checked then
						if self.IsChecked==nil then return end
						fn(k,i)
						Opt.Update()
					end
				end
			end
		end
		
		function self:SetVal(k)
			--Can send numbers or anything to a checkbox
			
			if type(k)=="number" then if k==0 then k=false else k=true end end
			
			if type(k)=="boolean" then
				self:SetChecked(k) 
			end
		end
	end
	
	
Opt.Radio=class(Turbine.UI.ListBox)

function Opt.Radio:Constructor(text,fn)
	--If a CollapseBox EVER contains a Radio then always use "f",1 or it will not resize the columns.
	Turbine.UI.ListBox.Constructor(self)
	
	self:SetSize(50,16*#text)
	self:SetOrientation( Turbine.UI.Orientation.Horizontal )	
	
	self.SizeChanged=function()
		--Just for testing purposes...
		local w=self:GetWidth()
		local c
		if w<=300 then c=1 end
		if w>300 then c=math.floor(w/300) end
		w=math.floor(w/c)
		
		--self:SetMaxItemsPerLine(c)
		self:SetMaxColumns(c)
		
		for i=0,#self.Radio do
			self.Radio[i]:SetWidth(w)
		end
		
		h=math.ceil(self:GetItemCount()/c)*16
		self:SetHeight(h)
		
	end

	--Create the checkboxes that function as radio buttons
		self.Radio={}
	--1: Scan text (Which should be a table). First entry is the "nil" setting. Create a checkbox for each level.
		
		for k=0,#text-1 do
			self.Radio[k]=Turbine.UI.Lotro.CheckBox()
			self.Radio[k]:SetSize(50,16)
			self.Radio[k]:SetText(text[k+1])
				
			--self.Radio[k]:SetBackColor(Turbine.UI.Color(0.5,math.random(0,1),math.random(0,1),math.random(0,1)))
			self.Radio[k].CheckedChanged=function()
				if self.Changing then return end
				if Opt.UpdateFlag then return end
				self.Changing=true
				if k==nil then k=0 end
				if k==true then k=1 end
				if k==false then k=2 end
				for j=0,#text-1 do
					self.Radio[j]:SetChecked(j==k)
				end
				for i=1,#Bar do
					if Bar[i].delete==false then
						if Bar[i].Checked then 
							fn(k,i)
						end
					end
				end
				self.Changing=false
				Opt.Update()
			end		
			self:AddItem(self.Radio[k])
		end
		
	--SetVal - what happens? This is essentially the same as CheckChanged, but without calling the function.
	function self:SetVal(k)
		if self.Changing then return end
		if k==nil then k=0 end
		if k==true then k=1 end
		if k==false then k=2 end
		
		self.Changing=true
		
		if type(k)=="string" then
			for j=0,#text-1 do
				self.Radio[j]:SetChecked(self.Radio[j]:GetText()==k)
			end
		else			
			for j=0,#text-1 do
				self.Radio[j]:SetChecked(j==k)
			end
		end
		self.Changing=false
	end
end

Opt.DropDown=class(Turbine.UI.Control)

function Opt.DropDown:Constructor(text,fn,label)
	Turbine.UI.Control.Constructor(self)
	--[[Structure: 	Backdrop, Label, Button]]
	--[[Events:		SizeChanged, SetVal]]
	
	self.Children={}
	
	self.Children.Backdrop=Turbine.UI.Control()
	self.Children.Backdrop:SetBackColor(Turbine.UI.Color(240/256,230/256,140/256))
	self.Children.Backdrop:SetParent(self)
	
	self.Children.DDLabel=optionlabel(320,label,true)
	self.Children.DDLabel:SetParent(self.Children.Backdrop)
	self.Children.DDLabel:SetBackColor(Turbine.UI.Color(0,0,0))
	self.Children.DDLabel:SetSize(0,0)
	
	self.Children.DDValue=optionlabel(320,"Text Here",true)
	self.Children.DDValue:SetParent(self.Children.Backdrop)
	self.Children.DDValue:SetBackColor(Turbine.UI.Color(0,0,0))
	self.Children.DDValue:SetPosition(1,1)
	
	self.Children.Button=Turbine.UI.Control()
	self.Children.Button:SetBackground(0x4100028F)
	self.Children.Button:SetParent(self.Children.DDValue)
	self.Children.Button:SetSize(10,10)
	self.Children.Button:SetBlendMode( Turbine.UI.BlendMode.Overlay )
	
	self.Children.Button.MouseDown=function()
		local contextMenu = Turbine.UI.ContextMenu()
		contextMenu.items = contextMenu:GetItems()

		local option={}
		
		for k=1,#text do
			option[k] = Turbine.UI.MenuItem(text[k], true)
			option[k].Click = function () 
			if self.Changing then return end
			if Opt.UpdateFlag then return end
			self.Changing=true
			if k==nil then k=0 end
			if k==true then k=1 end
			if k==false then k=2 end
			for i=1,#Bar do
				if Bar[i].delete==false then
					if Bar[i].Checked then 
						fn(k-1,i)
					end
				end
			end
			self.Changing=false
			self.Children.DDValue:SetText(text[k])
			Opt.Update()
		 end

		contextMenu.items:Add(option[k])
		end
		
		contextMenu:ShowMenu()
	end
	
	
	self:SetSize(300,20)
	
	self.SizeChanged=function()
		local w=self:GetWidth()
		if label==nil then
			self.Children.Backdrop:SetSize(w,20)
			self.Children.DDValue:SetSize(w-2,18)
			self.Children.Button:SetPosition(w-14,5)
		else
			self.Children.DDLabel:SetSize(w*0.2,20)
			self.Children.Backdrop:SetSize(w,20)
			self.Children.DDValue:SetSize(w-2-w*0.2,18)
			self.Children.DDValue:SetPosition(w*0.2+1,1)
			self.Children.Button:SetPosition(w-2-w*0.2-12,5)
		end
		
	end
	
	function self:SetBackColor(Color)
		if Color==nil then Color=Turbine.UI.Color(0,0,0) end
		self.Children.DDValue:SetBackColor(Color)
	end
	
	function self:SetVal(k)
		if self.Changing then return end
		if k==nil then k=0 end
		if k==true then k=1 end
		if k==false then k=2 end
		
		self.Changing=true
	
		if type(k)=="string" then
			self.Children.DDValue:SetText(k)
		else
			self.Children.DDValue:SetText(text[k+1])
		end
		
		self.Changing=false
	end
end
	
	Opt.Create()