--Every Bar is just a window with children quickslots.
--[[Structure;
		self
			.Window 			- contains the window
			.Quickslot[i]		- all the quickslots
			.Data				- sx,sy,gap,pad,size,name,color={opacity,r,g,b},x,y,name
			]]--
--[[Where modules *need* to reference

	Any new plugins that have a context menu need to add themselves to the list in Constructor at approx line 95.
	New proc modules need to be listed in the if statement below that.
	
	At the end of the file there is a function ModulesShowHide(). Proc modules should be added here so that bars will automatically be visible when the UI is unlocked and update themselves when the UI is unlocked again.
		]]--
		
	--[[Note: ** is a NASTY HACK for alias type shortcuts. 
		Without this hack alias types could not be dragged/dropped between bevy bars and had to be recreated every time. 
		What I do is store the alias, then wait for one cycle (SetWantsUpdates) to see if the shortcut has not been set. If it has - fine. Move along! Otherwise wait. If a shortcut is there, do nothing, otherwise set the alias. This avoids teh previous bug.
		]]
				
NewBar=class(Turbine.UI.Control)

--The constructor really just creates an empty window
function NewBar:Constructor()
	--Create the Window to hold the controls
		self.Window=Turbine.UI.Window()
		self.Window:SetVisible(true)
	
	--Initialise Data
		self.Data={}
		self.Data.name=""
		self.delete=false
		self.Callback={}
		
	--Add a DragBar (Thanks DeusDictum!)
		self.DragBar = Deusdictum.UI.DragBar( self.Window,"Drag Bar")
		self.DragBar:SetZOrder(9999)
		self.Window.HUDShow=function () ModulesShowHide() end
		
		if Watcher.flag then self.DragBar:SetDraggable(true) end --Show bar if HUD is unlocked
end

function NewBar:ShowButton(show)
if show then
	 --Add the Button. No longer Big & Red!
		self.Button=Turbine.UI.Control()		
		self.Button :SetPosition			( 4,4)
		self.Button :SetSize				( 16,16 )
		self.Button :SetVisible 			( true )
		self.Button :SetOpacity				( 1 )
		self.Button :SetStretchMode			( 1 )
		self.Button :SetParent				( self.Window)
		
		if self.Data.lock then
			self.Button:SetBackground	(0x41007e26)
		else
			self.Button:SetBackground 	(0x41007e27)
		end
		
		self.Button :SetZOrder			(9999)
		
	--Register button click to open the menu
	self.Button.MouseDown = function( sender, args )
		-- build the menu items in the context menu
		local contextMenu = Turbine.UI.ContextMenu();
		local contextMenuItems = contextMenu:GetItems();

		local lockbar = Turbine.UI.MenuItem( "Lock Shortcuts on "..self.Data.name,true,self.Data.lock);
			lockbar.Click = function( sender, args )
				self.Data.lock=not(self.Data.lock)
			if self.Data.lock then self:Lock() else self:Unlock() end
			end
			contextMenuItems:Add( lockbar )
			
		local addbar=Turbine.UI.MenuItem( "Add Bar ")
			addbar.Click = function( sender, args )
				i=#Bar+1
				Bar[i]=NewBar()
				Bar[i]:SetSize(3,3)
				Bar[i]:SetPosition(0,20)
				Bar[i]:SetColor({1,0,0,0})
				Bar[i]:ShowButton(true)
				renamebars()
				--Call the snapper setting
				Bar[i]:Snapper()
			end
		contextMenuItems:Add( addbar )	
			
		local deletebar=	Turbine.UI.MenuItem( "Delete Bar "..self.Data.name)
			deletebar.Click = function( sender, args )
				self:Delete()
			end
			contextMenuItems:Add( deletebar )

		local copybar=Turbine.UI.MenuItem( "Copy Bar (Settings only)")
			copybar.Click = function( sender, args )
				i=#Bar+1
					--Given a target name copy the current bar, not shortcuts - just the settings.
				Bar[i]=NewBar()
				Bar[i].Data=deepcopy(self.Data)
				Bar[i]:SetSize()
				Bar[i]:SetPosition(0,20)
				Bar[i]:SetColor(self.Data.color)
				Bar[i]:SetName(self.Data.name.."'")
				if Modules.skin and self.Data.skin~=nil then 				Bar[i]:Skin() 	end 
				if Modules.popups and self.Data.popup~=nil then 	Bar[i]:PopUp() end

				renamebars()
				--Call the snapper setting
				Bar[i]:Snapper()
				Bar[i]:ShowButton(true)
				if Modules.hider~=nil		then BarUpdate()					end
			end
			contextMenuItems:Add( copybar )	
		
		--Load optional modules		
		for i=1,#Context do
			Context[i](self,contextMenu,contextMenuItems)
		end
		
		--Option window link.
		local showoption=Turbine.UI.MenuItem( "Show other Options")
			showoption.Click=function(sender,args)
				for i=1,#Bar do
					if Bar[i].delete==false then Bar[i].Checked=false end
				end
				Opt.Update(self)
			end
			contextMenuItems:Add( showoption)			
			
		contextMenu:ShowMenu();
		end
	else
		if self.Button~=nil then
			self.Button:SetVisible(false)
			self.Button=nil
		end
	end
end

--Set Size creates or reshuffles the quickslots in the bar. I have decided NOT to delete any quickslots until the bar is deleted
--NINDYR Patch : changed args
--function NewBar:SetSize(sx,sy,pad,gap,size)
function NewBar:SetSize(sx,sy,pad,gap,size,padl,padr,padt,padb)
		--Defaults
	sx,sy=sx or self.Data.sx,sy or self.Data.sy
	pad=pad or self.Data.pad or 2
	--NINDYR Patch
	padl=padl or self.Data.padl or pad
	padr=padr or self.Data.padr or pad
	padt=padt or self.Data.padt or pad
	padb=padb or self.Data.padb or pad
	--end Patch
	gap=gap or self.Data.gap or  2
	size=size or self.Data.size or 36
	--NINDYR Patch
	--self.Data.sx,self.Data.sy,self.Data.pad,self.Data.gap,self.Data.size=sx,sy,pad,gap,size
	self.Data.sx,self.Data.sy,self.Data.pad,self.Data.gap,self.Data.size,self.Data.padl,self.Data.padr,self.Data.padt,self.Data.padb=sx,sy,pad,gap,size,padl,padr,padt,padb
	
	--There is a border around each icon. I think it is given by the size of the icon/10. This could be wrong!
	--[[NOTE: 
					I have tried to find a way around this, including thinking about allowing gap to be negative, so that overlapping icons becomes possible.
					However, it is not important enough to mess with. It only became an issue when the skin module became active. What it DOES mean is
					that when the icon size is set to 64 the window that contains it is only 58 pixels wide if there is no padding or gap. Thus, the icon size in
					the options will not match the real world.]]--
	local adjust=math.floor(size/10)
	--If there are no quickslots then define one.
	if self.Quickslot==nil then self.Quickslot={} end
	--If the bar contains less quickslots than it's size then create the quickslots
	if (sx*sy)>(#self.Quickslot) then 
		for i=#self.Quickslot+1,sx*sy do
			self.Quickslot[i]=NewQuickslot(size)
		end
	end
	--Resize the Window
	--self.Window:SetSize(pad*2+sx*(size+gap-adjust)-gap,pad*2+sy*(size+gap-adjust)-gap)
	--NINDYR Patch
	self.Window:SetSize(padl+padr+sx*(size+gap-adjust)-gap,padb+padt+sy*(size+gap-adjust)-gap)
	--end Patch
	self.DragBar:RecalculateSize()
	--Position the quickslots
	n=1
	for i=1,sx do
		for j=1,sy do
			self.Quickslot[n]:SetParent(self.Window)
			self.Quickslot[n]:SetVisible(true)
			self.Quickslot[n]:SetStretchMode(1)
			self.Quickslot[n].size=size
			self.Quickslot[n]:SetSize(size,size)
			self.Quickslot[n]:SetPosition(padl+(i-1)*(size+gap-adjust)-adjust,padt+(j-1)*(size+gap-adjust)-adjust)
			n=n+1
		end
	end
	--Hide, for now, the unused quickslots are hidden. This is to save them just in case we resize them back. I have made the mistake of losing skills too often! Will be deleted on next re-load
	for i=n,#self.Quickslot do
		self.Quickslot[i]:SetVisible(false)
	end
	
	--Lock or Unlock
	if self.Data.lock then self:Lock() else self:Unlock() end
	
	if Watcher.flag then
		--If the PopUp module, and this is a pop-up bar, is loaded then move the PopUp button marker
		if Modules.popups then if self.Data.popup~=nil and self.PopButton~=nil then self:MovePopBackDropButton() end end
		--"Position' the bar so that it stays in the display
		self:SetPosition(self:GetPosition()) --The set position function contains the "corrector" for off screen display!
	end
end

function NewBar:SetColor(color)
	if type(color)~="table" then color={1,0,0,0} end
	color[1]=color[1] or 1
	color[2]=color[2] or 0.1
	color[3]=color[3] or 0.1
	color[4]=color[4] or 0.1	
	self.Data.color=color
	self.Window :SetBackColor ( Turbine.UI.Color(color[1],color[2],color[3],color[4] ))
end

--Lock a bar
function NewBar:Lock()
	self.Data.lock=true
	for i=1,#self.Quickslot do
		self.Quickslot[i]:Lock()
	end
	if self.Button~=nil then self.Button :SetBackground	(0x41007e26) end
end

--Unlock a bar
function NewBar:Unlock()
		self.Data.lock=false
	for i=1,#self.Quickslot do
		self.Quickslot[i]:Unlock()
	end
	if self.Button~=nil then self.Button :SetBackground	(0x41007e27) end
end
	
--Delete a bar
function NewBar:Delete()
	--To make this easier the bar is now NOT deleted until the game is being unloaded.
	--This way I can be avoid all the bugs that were cropping up!
	self.Window:SetVisible(false)
	self.DragBar:SetVisible(false)
	self.DragBar:SetWantsKeyEvents(false)
	self.delete=true
	
	--Rename the bars to preserve name integrity
	renamebars()
	
	--Close the option window if it is open
	if Opt~=nil then
		if Opt.Window:IsVisible() then Opt.Update() end
	end
	if Modules.hider~=nil	then BarUpdate() end
end	
	
--Name a bar
function NewBar:SetName(s)
	--Mainly just keyed into DragBar.
	self.Data.name=s
	self.DragBar.sName=s
	self.DragBar.Label:SetText( s )
	--And labelling, if enabled.
	if Modules.label and self.Data.label~=nil then	self:Label()	end
end

--Get the bar position
function NewBar:GetPosition()
	self.Data.x,self.Data.y=self.Window:GetPosition()
	return self.Data.x,self.Data.y
end
function NewBar:GetLeft()
	self.Data.x,self.Data.y=self.Window:GetPosition()
	return self.Data.x
end
function NewBar:GetRight()
	self.Data.x,self.Data.y=self.Window:GetPosition()
	return self.Data.x+self.Window:GetWidth()
end
function NewBar:GetTop()
	self.Data.x,self.Data.y=self.Window:GetPosition()
	return self.Data.y
end
function NewBar:GetBottom()
	self.Data.x,self.Data.y=self.Window:GetPosition()
	return self.Data.y+self.Window:GetHeight()
end
function NewBar:SetPosition(x,y)
	--calculate whether this would place the frame off screen and if so, move it.
	local dw=Turbine.UI.Display:GetWidth()
	local dh=Turbine.UI.Display:GetHeight()
	local fw=self:GetWidth()
	local fh=self:GetHeight()
	if x==nil then x=0 end
	if y==nil then y=0 end
	if x+fw>dw then x=dw-fw end
	if y+fh>dh then y=dh-fh end
	if x<0 then x=0 end			--Prefer top-left over bottom-right.
	if y<0 then y=0 end
	
	self.Data.x,self.Data.y=x,y
	self.Window:SetPosition(x,y)
	self.DragBar:RecalculatePosition()
end

function NewBar:GetSize()
	return self.Window:GetSize()
end
function NewBar:GetWidth()
	return self.Window:GetWidth()
end
function NewBar:GetHeight()
	return self.Window:GetHeight()
end

--Opacity function
function NewBar:SetOpacity(o)
	if o==nil then o=1 end	--Default to full opacity
	self.Window:SetOpacity(o)
	for i=1, #self.Quickslot do
		self.Quickslot[i]:SetOpacity(o)
		if Modules.skin and self.Data.skin~=nil then for j=1,#self.SkinControl do self.SkinControl[j]:SetOpacity(o) end end
	end
end

function NewBar:GetOpacity()
	return self.Window:GetOpacity()
end

--Show/Hide Functions *Modified to play nicely with fader, also modificiation to perform either a hard hide or soft fade depeneding on the value of self.Data.fade*
function NewBar:Hide()
--Wierd thing. The show and hide functions are now EXACTLY THE SAME! Yes, very, very odd...
--This is due to the hide/show functions now being flag checkers rather than anything else...
self:Show()
end

function NewBar:Show()
	--If the bar is flagged for deletion, then just return
	if self.delete then return end
	--If the UI is unlocked, just show the bar already!
	if Watcher.flag then self.Window:SetVisible(true) self:SetOpacity(1) return end
	--On a /BB Show show everything
	if ShowBars	then self.Window:SetVisible(true) self:SetOpacity(1) return end
	--If the UI is hidden then return. Yes, this could cause problems.
	if not(HudVisible) then return end
	
	--Check whether the bar is set to fade, due to a PROC, rather than stance. Stance is handled below.

		--Decide whether to show or not - If any of these are false then the bar will NOT show.
		local show=true
		if Modules.stance then
			if self.Data.stance~=nil then show=show and self.InStance end
		end
		
		--Moved from line 391
		if Modules.fader then 
			if Player:IsInCombat() then
				self:SetOpacity(self.Data.icmn)
			else
				self:SetOpacity(self.Data.oocmn)
			end
		else
			self:SetOpacity(1)
		end
		
		if Proc then
			if self.Data.proc~=nil then 
				if self.Proc then
					--Nothing here right now...
				else
					if self.Data.fade then
						self:SetOpacity(self.Data.fade)
					else
						show=false
					end
				end
			end
		end
		
		if Modules.LPM then
			if self.Data.PowerBar~=nil then show=show and self.LowPower end
			if self.Data.MoraleBar~=nil then show=show and self.LowMorale end
		end
		if Modules.hider~=nil then
			if self.Data.hider~=nil then show=show and self.Data.hider.vis end
		end
		if Modules.Debuff then
			if self.Data.Debuff~=nil then show=show and self.Debuff end
		end
		
		if Modules.Monitor then
			if self.Data.monitor~=nil then show=show and self.InMonitor end
		end
		
		if Modules.Combat then
			if self.Data.Combat~=nil then show=show and self.Combat end
		end
		
		if Modules.Mount then
			if self.Data.Mount~=nil then show=show and self.Mount end
		end
		
		if Modules.KeyModifiers then 
			if self.Data.KM~=nil then show=show and self.KMShow end
		end
		
		if self.Data.other~=nil then show=show and self.Data.other end	--This is for the timer plugin, which can broadcast to Bevy. Unlikely to get released, so this line is just for me!
		
		self.Window:SetVisible(show)
		
	self.Data.visible=show
end


--Returns whether the current bar is fully visible, or not.
function NewBar:IsVisible()
	return self.Window:IsVisible()
end

--Good old PSetShortcut. Stops those nasty errors...
Turbine.UI.Lotro.Quickslot.PSetShortcut=function(target,source)
	pcall(function () target:SetShortcut(source) end)
end

--Extended quickslot class

NewQuickslot=class (Turbine.UI.Lotro.Quickslot)
function NewQuickslot:Constructor (size)
	Turbine.UI.Lotro.Quickslot.Constructor(self)
	self.size=size
	self.ShortcutChanged=function(sender, args)
		if self.size~=36 then self:SetStretchMode(1) end
		self:SetSize(self.size,self.size)
	end
end

function NewQuickslot:Unlock()
	--Unlock the slot and enable events
	self:SetAllowDrop (true)
	self.MouseDown = function(sender,args)
		self.draggingShortcut = true;
		--**
		ss=self:GetShortcut()
		if ss:GetType()~=Turbine.UI.Lotro.ShortcutType.Alias then ss=nil end
		--**
	end

	self.MouseLeave = function(sender,args)
		if(self.draggingShortcut) then
			self.draggedOut = true;
		end
	end

	self.MouseUp = function(sender,args)
		if(args.Button == Turbine.UI.MouseButton.Left) then
			if(self.draggedOut) then
				--Clear previous slot
				self:PSetShortcut()
				self:SetVisible(true)
				source=self
			end
		end
		self.draggedOut=false
		self.draggingShortcut = false
	end
	
	self.DragEnter = function(sender,args)
		--Store the *possible* target shortcut.
		local short=self:GetShortcut()
		if short~=nil then
			target={}
			target.Data=short:GetData()
			target.Type=short:GetType()
			if target.Type==0 then target=nil end
		end
	end
	
	--Change of perspective now.
	self.DragDrop = function(sender,args)
		if ss~=nil then self:SetWantsUpdates(true) end		--**
		local short=self:GetShortcut()
		if short==nil 	then return end
		if source==nil 	then return end
		if target==nil 	then return end
		--if short:GetType()~=0 then return end
		source:PSetShortcut(Turbine.UI.Lotro.Shortcut( target.Type,target.Data ))
		source=nil
		target=nil
	end
end

--**
function NewQuickslot:Update()
	self:SetWantsUpdates(false)
	if self:GetShortcut():GetType()~=0 then
		ss=nil
	else
		self:PSetShortcut(ss) 
		ss=nil
	end
end

function NewQuickslot:Lock()
	--Lock the slot and disable events
	
	--Now, for some odd reason just disabling dropping didn't work - these events sort it out!
	
	--** self.MouseDown =nil	Line removed for NASTY HACK!
	--**
	self.MouseDown = function(sender,args)
		ss=self:GetShortcut()
		if ss:GetType()~=Turbine.UI.Lotro.ShortcutType.Alias then ss=nil end
	end
	--**
	self.MouseLeave = nil
	self.MouseUp =nil
	self.DragEnter =function (Sender,args)
		target=self:GetShortcut()
	end
	self.DragDrop = function (Sender,args)
		self:PSetShortcut(target)
	end
	self:SetAllowDrop (false)
end

function MakeWatcher()
--Create control to watch for the UI being unlocked, this will then scan the buttons and make them all visible.
Watcher=Turbine.UI.Control()
HudVisible=true		--HUD visible?
Watcher.flag=false	--Unlocked flag
Watcher:SetWantsKeyEvents(true)
	Watcher.KeyDown = function(sender, args)
		if (args.Action == 268435579) then
		Watcher.flag=not(Watcher.flag)
		--reveal or hide all buttons
			for i=1,#Bar do
				Bar[i]:ShowButton(Watcher.flag)
				if Modules.Store then Bar[i]:flagshared() end
			end
		--Module stuff
			ModulesShowHide()
		elseif (args.Action == 268435635) then
			--This is the toggle for the HUD being visible.
			HudVisible=not(HudVisible)
			--if the hud is visible then show/hide all the bars as appropriate
			if HudVisible then ModulesShowHide() end
		end
	end
end

function ModulesShowHide()
--Used in watcher, or elsewhere, to show or hide the bars due to the Watcher.flag
	if Watcher.flag then
		if Modules.popups then CloseAllPops() OpenAllPops() end --Does both to avoid a bug
		for i=1,#Bar do Bar[i]:Show() end
	else
		if ShowBars then return end
		if Modules.fader			then for i=1,#Bar do Bar[i]:SetOpacity(Bar[i].Data.oocmn) end end
		if Modules.stance 			then stanceupdate() 			end
		if Modules.popups 			then CloseAllPops() 			end
		if Proc 					then procupdate() 				end
		if Modules.hider~=nil		then BarUpdate()				end
		if Modules.LPM				then LPMUpdate()				end
		if Modules.Debuff 			then DebuffUpdate()				end
		if Modules.Monitor			then monitorupdate()			end
		if Modules.Combat			then scancombat()				end
		if Modules.Mount			then scanMount()				end
	end
end

--Make the invisible watcher control if it does not exist. This controls the locking and unlocking of frames
if Watcher==nil then MakeWatcher() end