--Modules will need to add themselves to the load and save sections here - have look below.
--
Player = Turbine.Gameplay.LocalPlayer.GetInstance()
PlayerClass=Player:GetClass()
PlayerAttributes=Player:GetClassAttributes()
effects = Player:GetEffects()

classes={}	for i,v in pairs(Turbine.Gameplay.Class) do classes[v]=i end
--194 - Warden is missing from the table!
classes[194]="Warden"

Debufftext={} for i,v in pairs(Turbine.Gameplay.EffectCategory) do Debufftext[v]=i end

font={}
	j=1
	for i in pairs(Turbine.UI.Lotro.Font) do 
		if i~="IsA" then
			font[j]=i
			j=j+1
		end
	end
	table.sort(font, function (a,b)	
			return (a < b) 
	 end)
	 
align={}
		j=1
		for i in pairs(Turbine.UI.ContentAlignment) do 
			if i~="IsA" then
				align[j]=i
				j=j+1
			end
		end
		table.sort(align, function (a,b)	
				return (a < b) 
		 end)


--This funtion renames the bars upon deletion or inital program run. Any bars starting "Bevy Bar" will be changed...
function renamebars()
	local index=0
	for i=1,#Bar do
		if not(Bar[i].delete) then 
			index =index+1
			--Trap basic names - do not replace special names, but replace nil or null names!
			local name=Bar[i].Data.name
			if string.sub (name,1,8)=="Bevy Bar" or name==nil or name=="" then 
				Bar[i]:SetName("Bevy Bar "..index)
			end
		end
	end
end

--Loads the settings
function Load()
	--Load Data and set defaults if none there
	local i=JackdawPlugins.Patch.Load( Turbine.DataScope.Character, "BevyOBars2" )
	if i~=nil then if #i>1 then Data,Modules,collect,other,Store=i[1],i[2],i[3],i[4],i[5] else Data=i Modules={} other={} Store={} end end

	if type(Data)~="table" then
		Data={}
		Data[1]={sx=1,sy=12,gap=2,pad=2,size=36}
		Modules={}
		import "JackdawPlugins.Bevy2.ModuleOption" ShowModuleOption()
		ColorWrite(0.5,0.5,0.5,"Welcome to Bevy O' Bars II. Type /BB for some options, or unlock the display and use The Big Button for bar specific options.")
	end

	if Modules==nil then Modules={} end

	if other~=nil then
		Opt.Width=other.Opt.Width
		Opt.Height=other.Opt.Height
	else
		Opt.Width=400
		Opt.Height=400
	end
	
	--Now, a link across from the autoloader option that allows you to zero out any modules - in case of corrupted data or bugs.
	if loadmodules==nil then loadmodules=true end
	
	if not loadmodules then Modules=nil Modules={} end
	
	--Import some modules; Fader needs to be present BEFORE creating the bars.
	if Modules.fader then import "JackdawPlugins.Bevy2.fader" end
	
	Build()
end

function Build()
	--Initialise the Bar store.
	if Bar~=nil then Bar=nil end
	Bar={}
	for i=1,#Data do
		--I could just DeepCopy the data BUT have not - this is so that some data is deliberately lost.
		Bar[i]=NewBar()
		if Data[i].sx==nil then Data[i].sx=1 end
		if Data[i].sy==nil then Data[i].sy=1 end
		--Setting the size twice avoids a bug with a clipped pixcel. See below...
		--NINDYR Patch
		--Bar[i]:SetSize(Data[i].sx,Data[i].sy,Data[i].pad,Data[i].gap,Data[i].size,Data[i].lock)
		Bar[i]:SetSize(Data[i].sx,Data[i].sy,Data[i].pad,Data[i].gap,Data[i].size,Data[i].padl,Data[i].padr,Data[i].padt,Data[i].padb)
		Bar[i]:SetPosition(Data[i].x,Data[i].y)
		Bar[i]:SetColor(Data[i].color)
		Bar[i]:SetName(Data[i].name or "Bevy Bar "..i)
		Bar[i]:Show()
		
		--Call the snapper setting
		loading=true
		Bar[i]:Snapper()
		loading=nil
		
		Bar[i].Data.fade= Data[i].fade

		Bar[i].Data.oocmo=		Data[i].oocmo
		Bar[i].Data.icmo=		Data[i].icmo
		Bar[i].Data.oocmn=		Data[i].oocmn
		Bar[i].Data.icmn=		Data[i].icmn
		Bar[i].Data.hider=		deepcopy(Data[i].hider)
		Bar[i].Data.Debuff=		Data[i].Debuff
		Bar[i].Data.Combat=		Data[i].Combat
		Bar[i].Data.Mount=		Data[i].Mount
		Bar[i].Data.Shared=		Data[i].Shared
		Bar[i].Data.KM=			Data[i].KM
		
		if Data[i].skin~=nil then if type (Data[i].skin)=="string" then Bar[i].Data.skin= string.gsub(Data[i].skin, ".tga", "") end end--The gsub here removes the .tga extension. I made a switch in the coding. Remove the gsub at a later date when everyone is compatible.
		Bar[i].Data.label=		deepcopy(Data[i].label)

		Bar[i].Data.PowerBar=	Data[i].PowerBar
		Bar[i].Data.MoraleBar=	Data[i].MoraleBar

		Bar[i].Data.monitor=Data[i].monitor	Bar[i].Data.monitorNOT=Data[i].monitorNOT
		
		if Data[i].lock then Bar[i]:Lock() else Bar[i]:Unlock() end
		
		--Modules data copied over.
		
		if Data[i].stance~=nil then Bar[i].Data.stance=deepcopy(Data[i].stance) end
		Bar[i].Data.popup=Data[i].popup
		Bar[i].Data.proc=Data[i].proc
			
		if Data[i].shortcut~=nil then
			for j=1,Data[i].sx*Data[i].sy do
				if Data[i].shortcut~=nil then 
					Bar[i].Quickslot[j]:PSetShortcut( Turbine.UI.Lotro.Shortcut( Data[i].shortcut[j].Type,Data[i].shortcut[j].Data ))
				end
			end
		end
		
		--Setting the size twice avoids a bug with a clipped pixel. Odd, but nessecary!
		--NINDYR Patch
		--Bar[i]:SetSize(Data[i].sx,Data[i].sy,Data[i].pad,Data[i].gap,Data[i].size,Data[i].lock)
		Bar[i]:SetSize(Data[i].sx,Data[i].sy,Data[i].pad,Data[i].gap,Data[i].size,Data[i].padl,Data[i].padr,Data[i].padt,Data[i].padb)
	end	
	
	--Initialise or load plugins.

	if MLoaded then 
		if Modules.skin then 					intialiseskin() 		end
		if Modules.fader then					initialisefader() 		end
		if Modules.hider~=nil then 				BarUpdate() 			end
		if Modules.popups then 					initialisepopups() 		end
		if Modules.runekeeper or Modules.captain or Modules.guardian or Modules.burglar or Modules.minstrel or Modules.champion or Modules.hunter then procupdate() end
		if Modules.LPM then						LPMUpdate() 			end
		if Modules.Debuff then					InitialiseDebuff()		end
		if Modules.Monitor then					initialisemonitor()  	end
		if Modules.Combat then					scancombat() 			end	
		if Modules.Mount then					scanMount() 			end	
		if Modules.label then					intialiselabel() 		end
		if Modules.KeyModifiers then			KM.initialise()			end
		
		--Stance must come last!
		if Modules.stance then 					initialisestance() 		end
	else
		MLoaded=true
		if Modules.skin then 					import "JackdawPlugins.Bevy2.skin" 				end 
		if Modules.fader then					initialisefader() 								end
		if Modules.hider~=nil then 				import "JackdawPlugins.Bevy2.Hider" 			end
		if Modules.popups then 					import "JackdawPlugins.Bevy2.PopUps" 			end
		if Modules.runekeeper then	 			import "JackdawPlugins.Bevy2.Runekeeper" 		end
		if Modules.captain then 				import "JackdawPlugins.Bevy2.Captain" 			end
		if Modules.guardian then 				import "JackdawPlugins.Bevy2.Guardian" 			end
		if Modules.burglar then 				import "JackdawPlugins.Bevy2.Burglar" 			end
		if Modules.minstrel then 				import "JackdawPlugins.Bevy2.Minstrel" 			end
		if Modules.champion then 				import "JackdawPlugins.Bevy2.Champion" 			end
		if Modules.hunter then 					import "JackdawPlugins.Bevy2.Hunter" 			end
		if Modules.LPM then						import "JackdawPlugins.Bevy2.LowPowerMorale" 	end
		if Modules.Debuff then					import "JackdawPlugins.Bevy2.Debuff" 			end
		if Modules.Monitor then					import "JackdawPlugins.Bevy2.Monitor"  			end
		if Modules.Combat then					import "JackdawPlugins.Bevy2.Combat" 			end	
		if Modules.Mount then					import "JackdawPlugins.Bevy2.Mount" 			end	
		if Modules.label then					import "JackdawPlugins.Bevy2.label" 			end
		if Modules.stance then 					import "JackdawPlugins.Bevy2.stance" 			end
		if Modules.Store then					import "JackdawPlugins.Bevy2.BarStore"			end
		if Modules.KeyModifiers then			import "JackdawPlugins.Bevy2.KeyModifiers"		end
	end	
end

--Save the settings!
function Save()
	if Modules.Store then 		Store.StoreButtonData=StoreButtonData SaveToStore(Store.Current) end	--Update the current store to match the bar setup.
	if Modules.popups then 		OpenAllPops() end --Popup module requires all popups to be open before saving. Otherwise it records the bar as being 1x1
	if Modules.Monitor then 	MergeList() end -- Attempt to overcome lost buffs.
	
	local Data={}
	local index=1
		for i=1,#Bar do
			--If the bar is marked for deletion, then ignore it. Otherwise - save away!
			if not(Bar[i].delete) then
				Data[index]=deepcopy(Bar[i].Data)
				Data[index].x,Data[index].y=Bar[i]:GetPosition()
				Data[index].shortcut={}
				for j=1,Data[index].sx*Data[index].sy do
					local shortcut=Bar[i].Quickslot[j]:GetShortcut()
					Data[index].shortcut[j]={}
					Data[index].shortcut[j].Data=shortcut:GetData()
					Data[index].shortcut[j].Type=shortcut:GetType()
				end
				index=index+1
			end
		end
	
	other={}
	other.Opt={}
	other.Opt.Width=Opt.Width
	other.Opt.Height=Opt.Height
		
	JackdawPlugins.Patch.Save( Turbine.DataScope.Character, "BevyOBars2", {Data,Modules,collect,other,Store} )
	ColorWrite(0.5,0.5,0.5,"BevyOBars 2 Unloaded and Saved")
	
	--If the Monitor Module is loaded then save the bufflist.
	if Modules.Monitor then 
		JackdawPlugins.Patch.Save( Turbine.DataScope.Account, "BevyOBars2Bufflist", bufflist )
	end
end

--[[**DeepCopy
Copies a table - completely and in a "Deep" way.
And LITERALLY - objects and all.
I do not pretend to understand the code of this.

From http://lua-users.org/wiki/CopyTable]]
function deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
				new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

--Register a command line...
shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, args)

	if args=="show" then 
		ShowBars=not(ShowBars)
		if ShowBars then Turbine.Shell.WriteLine("Bars will not hide till /BB Show again") else Turbine.Shell.WriteLine("Bars operating normally") end
		for i=1,#Bar do 
			if Bar[i].delete==false then
				Bar[i]:Show()
			end	
		end
	elseif args=="module" then import "JackdawPlugins.Bevy2.ModuleOption" ShowModuleOption() return 
	elseif args=="nobar" then
		i=#Bar+1
		Bar[i]=NewBar()
		Bar[i]:SetSize(3,3)
		Bar[i]:SetPosition(0,20)
		Bar[i]:SetColor({1,0,0,0})
		Bar[i]:ShowButton(true)
		renamebars()
		--Call the snapper setting
		Bar[i]:Snapper()
		return
	else
		ColorWrite(1,0,0,"Bevy-o-Bars Commands;")
		ColorWrite(0.5,0.5,0.5,"/BB module to select modules")
		ColorWrite(0.5,0.5,0.5,"/BB show to show all bars regardless of opacity or fade setting. To reset unlock, then lock the UI.")
		ColorWrite(0.5,0.5,0.5,"/BB nobar to create a bar, should you delete them all by accident.")
	end
	
end
Turbine.Shell.AddCommand('BB', shellCommand)

--Due to Pengoros... Many thanks!
--The proc modules DEPEND on this wonderful function!
function AddCallback(object, event, callback)
	--Next line added to stop a callback being added more than once.
	RemoveCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

-- safely remove a callback without clobbering any extras
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

--Color write - Thanks to Garan for helping me! Dec2Hex from http://pastebin.com/9LDBcdB5
function ColorWrite(R,G,B,txt)
	local hexchars = "0123456789ABCDEF"

	local function Dec2Hex(inp)
		if(inp == 0) then return "00" end
		outstr = ""
		while(inp > 0) do
			local c = inp % #hexchars
			outstr = hexchars:sub(c+1, c+1) .. outstr
			inp = math.floor(inp / #hexchars)
		end
		if string.len(outstr)==1 then outstr="0"..outstr end
		return outstr
	end
	Turbine.Shell.WriteLine("<rgb=#".. Dec2Hex(R*255) .. Dec2Hex(G*255) .. Dec2Hex(B*255) ..">"..txt.."</rgb>")
end

 optionlabel=class(Turbine.UI.Label)
 function optionlabel:Constructor(width,text,centre)
	Turbine.UI.Label.Constructor(self)
	self:SetSize( width, 20 );
	self:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self:SetFontStyle( Turbine.UI.FontStyle.Outline )
	self:SetText( text);
	if centre then self:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter ) end
end

optiontextbox=class(Turbine.UI.Lotro.TextBox)
function optiontextbox:Constructor(width,text)
	Turbine.UI.Lotro.TextBox.Constructor(self)
	self:SetSize(width,20)
	self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
	self:SetText(text)
end